template<int N, bool Oriented, typename _Node, typename _Edge>
struct Graph {
	std::vector<int> graph[1+N];
	_Node info[1+N];

	struct Edge {
		_Edge info;
		int a, b;
		
		Edge() {
		
		}

		Edge(int _a, int _b, _Edge _info) {
			a = _a;
			b = _b;
			info = _info;
		}
		
		int other(int x) {
			return a ^ b ^ x;
		}
	};
	
	std::vector<Edge> edge;

	void addEdge(int a, int b, _Edge x = 0) {
		graph[a].push_back(edge.size());
		if(!Oriented)
			graph[b].push_back(edge.size());

		edge.push_back(Edge(a, b, x));
	}
};

